/*
 * Created on Oct 30, 2006
 *
 * On trouve ici la pile
 * 
 * 
 * A savoir : 
 * 
 * 1) sommet de pile : S=0
 * 2) difficile gestion des erreurs en cas de dclaration d'tat mmoire avec parametre nul
 * 
 */

/**
 * @author Jean-Christophe1
 *
 * 
 */


package memoire;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;

import asa.*;


public class Memory {

	public HashMap pile;	
	public String StackTopIdent;
	public int StackTopPos;
	public Tas Tas;
	
	public Memory(int tailleTas)
	{
		//	 hash table construction
	    pile = new HashMap();
	    StackTopIdent="";
	    Tas = new Tas(tailleTas);
	    
	    /*
	    //Tas.launch();
	    System.out.println("");
		System.out.println("cration de newtab");
		System.out.println("");
		declTab("newtab", 8, "int");
		
		System.out.println("");
		System.out.println("cration de newtab");
		System.out.println("");
		declTab("newtab", 8, "int");
		
		System.out.println("");
		System.out.println("cration de newtab");
		System.out.println("");
		declTab("newtab", 8, "int");

		
		System.out.println("");
		System.out.println("cration de tab");
		System.out.println("");
		declTab("tab", 200, "int");
		
		showStack();
		
		LinkedList test=(LinkedList) pile.get("newtab");
		System.out.println("liste de newtab : "+test.toString());
		System.out.println("pile de newtab : "+pile.get("newtab"));
		
		
		System.out.println("");
		System.out.println("retrait de newtab");
		System.out.println("");
		retirerDecl("newtab");
		
		//retirerTas((descriptionTas) (((LinkedList) identTable.get("newtab")).getLast()));
	    
		String[] affichage=displayTas2(Tas.refTas);
		for(int i=0; i<affichage.length; i++){
			System.out.println(affichage[i]);
		}
	    
	    
	    Quadruplet a=new Quadruplet("a", "Valeur A", "Nature A", "Type A");
		Quadruplet b=new Quadruplet("b", "Valeur : b", "Nature : b", "Type : b");
		Quadruplet c=new Quadruplet("c", "Valeur A", "Nature A", "Type A");
		Quadruplet d=new Quadruplet("d", "Valeur : b", "Nature : b", "Type : b");
		Quadruplet e=new Quadruplet("e", "Valeur A", "Nature A", "Type A");
		Quadruplet f=new Quadruplet("f", "Valeur : b", "Nature : b", "Type : b");
		
		empiler(a);
		
		empiler(b);
		
		empiler(c);
		empiler(d);
		empiler(e);
		empiler(f);
		
		
		System.out.println("appelle declVar() aprs 3 empilages");
		declVar("a", "3", "sonType");
		showStack();
		
		
		System.out.println("appelle echanger()");
		echanger();
		showStack();
		
		System.out.println("appelle identVal()");
		identVal("b", "", 0);
		showStack();
		
		System.out.println("appelle depiler()");
		depiler();
		showStack();
		
		
		
		System.out.println("appelle depiler()");
		depiler();
		showStack();
		
		System.out.println("appelle retirerDecl(b)");
		retirerDecl("b");
		System.out.println("sommet de pile aprs retrait : "+StackTopIdent);
		showStack();
		
	    
	    Quadruplet a=new Quadruplet("a", "Valeur A", "Nature A", "Type A");
		Quadruplet b=new Quadruplet("b", "Valeur : b", "Nature : b", "Type : b");
		Quadruplet c=new Quadruplet("c", "Valeur : c", "Nature : c", "Type : c");
		
		System.out.println("empiler a");
		empiler(a);
		showStack();
		
		System.out.println("identval a");
		identVal("a", "var", 0);
		showStack();

		System.out.println("empiler b");
		empiler(b);
		showStack();
		
		System.out.println("identval b");
		identVal("b", "var", 0);
		showStack();
		
		System.out.println("empiler c");
		empiler(c);
		showStack();
		
		Quadruplet tmp = getStackTop();
		System.out.println("temp : "+tmp.toString());
		
		System.out.println("depiler");
		depiler();
		showStack();
		
		System.out.println("declmeth de c");
		declMeth("c",(String)tmp.getValue(),"type de c");
		showStack();

		empiler(a);
		empiler(b);
		empiler(a);
		System.out.println("appelle declVar() aprs 3 empilages");
		declVar("a", "3", "sonType");
		showStack();
		System.out.println("appelle echanger()");
		echanger();
		showStack();
		System.out.println("appelle identVal()");
		identVal("hello", "", 0);
		showStack();
		System.out.println("appelle depiler()");
		depiler();
		showStack();
		*/
	}
	
	public void creer(int tailleTas){
		try{
			new Memory(tailleTas);
		}
		catch(Exception e){
			System.out.println("Une erreur a eu lieu lors de la cration de la pile"+System.getProperty("line.separator"));
			e.printStackTrace();
		}
	}
	
	public void clearStack(){
		
		pile.clear();
		
	    StackTopIdent="";
	    StackTopPos=0;
	    if(pile.isEmpty()){
	    	System.out.println("Pile efface avec succs !");
	    }
	    
	}
	
	public Quadruplet getStackTop(){
		LinkedList sommet=((LinkedList) pile.get(StackTopIdent));
		return (Quadruplet) ((ArrayList) sommet.get(sommet.size()-1)).get(0);		
	}
	
//	parcourir la liste pour prendre l'lment qui a la position la plus leve dans la pile
	public Quadruplet getMaxElement(String ident){
		
		showStack();
		LinkedList elem=(LinkedList) pile.get(ident);
		return (Quadruplet)((ArrayList)(elem).getLast()).get(0);
		
		/*//TODO elem.size()+1 ???
		int temp=elem.size()-1;
		int i=0;
		while(temp!=Integer.parseInt((String)((ArrayList)(elem).get(i)).get(2)))
		{
			i++;
		}
		/*
		int maxIndice=0;
		int temp;
		for(int i=0; i<elem.size(); i++){
			temp=Integer.parseInt((String)((ArrayList)(elem).get(i)).get(2));
			if(temp>maxIndice){
				maxIndice=temp;
			}
		}*/
		
	}
	
	/**
	 * @param s 
	 * la profondeur dans la pile
	 * 
	 * @return 
	 * la liste de tous les lments ayant pour identifiant celui de profondeur "s"
	 */
	private LinkedList getElementList(int s) {

		try{
			String thisStackTopIdent=StackTopIdent;
			String pos=null;
			ArrayList StackDisplay=new ArrayList();
			ArrayList memSlot=new ArrayList();
			LinkedList l = (LinkedList) pile.get(StackTopIdent);;
			// building output
			while(s!=0){
				l=(LinkedList) pile.get(thisStackTopIdent);
				System.out.println("pos= "+pos+" taille liste : "+l.size());
				memSlot=(pos!=null)?((ArrayList) l.get(Integer.parseInt(pos)-1)):((ArrayList) l.getLast());
				
				//StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
				thisStackTopIdent=memSlot.get(1).toString();
				pos=memSlot.get(2).toString();
				s--;
			}
			return l;
		}catch(Exception e){
			System.out.println("impossible d'empiler. mmoire non dfinie ou pile non cre (getElementList()) : ");
			e.printStackTrace();
		}
		return null;
	}

	private int countList(String toFind,int s) {

		try{
			int toReturn=0;
			int counter=0;
			
			String thisStackTopIdent=StackTopIdent;
			String pos=null;
			ArrayList StackDisplay=new ArrayList();
			ArrayList memSlot=new ArrayList();
			LinkedList l = (LinkedList) pile.get(StackTopIdent);;
			// building output
			while(s!=0){
				counter++;
				l=(LinkedList) pile.get(thisStackTopIdent);
				memSlot=(pos!=null)?((ArrayList) l.get(Integer.parseInt(pos)-1)):((ArrayList) l.getLast());
				
				//StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
				thisStackTopIdent=memSlot.get(1).toString();
				pos=memSlot.get(2).toString();
				s--;
				if(thisStackTopIdent.equals(toFind)){
					toReturn++;
				}
			}

			
				return toReturn;


		}catch(Exception e){
			System.out.println("impossible d'empiler. mmoire non dfinie ou pile non cre : ");
			e.printStackTrace();
		}
		return -1;
	}
	
	private int getElementPos(int s) {

		try{
			int counter=0;
			int tempToReturn=0;
			String thisStackTopIdent=StackTopIdent;
			String pos=null;
			ArrayList StackDisplay=new ArrayList();
			ArrayList memSlot=new ArrayList();
			LinkedList l = (LinkedList) pile.get(StackTopIdent);;
			// building output
			while(s!=0){
				counter++;
				l=(LinkedList) pile.get(thisStackTopIdent);
				memSlot=(pos!=null)?((ArrayList) l.get(Integer.parseInt(pos)-1)):((ArrayList) l.getLast());
				if (pos!=null){
					tempToReturn=Integer.parseInt(pos);
				}
				//StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
				thisStackTopIdent=memSlot.get(1).toString();
				pos=memSlot.get(2).toString();
				s--;
			}
			if(counter==1){
				System.out.println("retourne taille liste");
				return(l.size());
			}
			else{
				System.out.println("retourne du vent");
				return tempToReturn;
			}
			
		}catch(Exception e){
			System.out.println("impossible d'empiler. mmoire non dfinie ou pile non cre : ");
			e.printStackTrace();
		}
		return -1;
	}
		
	/**
	 * @param Quadruplet 
	 * le quadruplet  ajouter
	 * 
	 */
	//ajout d'un quadruplet mmoire dans la table de hash
	public void empiler(Quadruplet element)
	{	
		LinkedList l;
		try {
			// Pas de collision : cration de l'lment dans la table de hash
			if(!pile.containsKey(element.getIdent())){
				l=new LinkedList();
			}
			// Collision : rcupration du contenu de la table de hash
			else{
				l=new LinkedList((LinkedList) pile.get(element.getIdent()));
				System.out.println("!! Collision de l'identifiant  ["+element.getIdent()+"].");
			}
			
			// Enfin, ajout de l'lement  sa place : hashslot 1 lment de la liste
			ArrayList HashSlot=new ArrayList(3);
			HashSlot.add(element);
			//Stack Top key
			System.out.println("adding : "+element.getIdent());
			HashSlot.add(StackTopIdent);
			//position de l'lment du sommet de pile dans sa liste
			try{
				l.size();
				HashSlot.add(Integer.toString(StackTopPos));
				//HashSlot.add(Integer.toString(((LinkedList) pile.get(/)).size()));
			}catch(Exception e){
				HashSlot.add(Integer.toString(0));
			}
			System.out.println("pos : "+HashSlot.get(2));
			l.add(HashSlot);
			pile.put(element.getIdent(), l);
			StackTopIdent=element.getIdent();
			
			StackTopPos=l.size();
		}catch(Exception e){
			System.out.println("impossible d'empiler. mmoire non dfinie ou pile non cre : ");
			e.printStackTrace();
		}
	}
	
	public void depiler()
	{
		//System.out.println(" StackTopPos : "+StackTopPos);
		LinkedList l=(LinkedList) pile.get(StackTopIdent);
		Quadruplet thisQuadrem=(Quadruplet) ((ArrayList) l.getLast()).get(0);
		//System.out.println("l size : "+l.size());
		
		//try{
			
			l=(LinkedList) pile.get(StackTopIdent);
			//System.out.println("l size : "+l.size());
			for(int i=0; i<l.size(); i++){
				//System.out.println(l.get(i)+"    "+i);
				
			}
			ArrayList memSlot=(ArrayList) l.get(StackTopPos-1);
			
			//System.out.println("taille de la liste avant dpiler : "+l.size());
			//dpilage
			l.remove(StackTopPos-1);
			
			
			//MAJ des variables globales
			StackTopIdent=(String) memSlot.get(1);
			StackTopPos=Integer.parseInt((String) memSlot.get(2));
			//System.out.println("nouveau sommet : "+StackTopIdent);
			
			//effacement de l'id dans la table de hash
			if (l.size()==0){
				pile.remove(thisQuadrem.ident);
			}
			//System.out.println("taille de la liste aprs dpiler : "+l.size());
	/*	}catch(Exception e){
			System.out.println("impossible de dpiler. Pile non cre ? message : ");
			e.printStackTrace();
			System.out.println("fin message");
		}*/
	}

	public void echanger()
	{
		Quadruplet sommet=getStackTop();
		depiler();
		Quadruplet sousSommet=getStackTop();
		depiler();
		empiler(sommet);
		empiler(sousSommet);
		/*
		ArrayList SecondSlot;
		//try{
			//identifiants du sommet
			LinkedList TopList=(LinkedList) pile.get(StackTopIdent);
			System.out.println ("list size : "+TopList.size()+" Stacktoppos : "+StackTopPos);
			ArrayList TopSlot=(ArrayList) TopList.get(StackTopPos-1);
			
			//identifiant du sous-sommet
			String ident=(String) TopSlot.get(1);
			LinkedList SecondList=(LinkedList)pile.get(ident);
			
			//MAJ des variables globales
			StackTopIdent=ident;
			StackTopPos=(Integer.parseInt((String) TopSlot.get(2)));
			
	
			if(TopList.equals(SecondList)){
				System.out.println("");
				System.out.println("!!!!! Les deux lements du sommet de pile sont les memes !!!!!");
				System.out.println("");
				//on inverse physiquement les quadruplets dans la liste
				SecondSlot=(ArrayList) SecondList.get(SecondList.size()-2);
				Object tempQuad=SecondSlot.get(0);
				SecondSlot.set(0, TopSlot.get(0));
				TopSlot.set(0, tempQuad);
			}
			else{
				SecondSlot=(ArrayList) SecondList.getLast();
	//			changement de pointeur vers la mmoire prcdente
				TopSlot.set(1, SecondSlot.get(1));
				SecondSlot.set(1, StackTopIdent);
				
				//changement de pointeur de position
				int tempElemPos=TopList.size()-1;
				TopSlot.set(2, SecondSlot.get(2));
				SecondSlot.set(2, Integer.toString(tempElemPos));
			}
		/*}catch(Exception e){
			System.out.println("impossible d'changer. Vrifier s'il y a au moins deux lments dans la pile ? message : ");
			e.printStackTrace();
		}*/
	}
	
	public void declVar(Quadruplet q)
	{	
		q.nature="var";
		empiler(q);
	}
	
	public void declVar(String ident, String value, String type){
		empiler(new Quadruplet(ident, value, "var", type));
	}

	public void declTab(String ident, int value, String type)
	{
		empiler(new Quadruplet(ident, Tas.creerTas(ident, value), "tab", type));
	}

	public void declCst(String ident, String value, String type){
	
		String nature;
		if(value.equals("")){
			nature="vcst";
		}
		else{
			nature="cst";
		}
		empiler(new Quadruplet(ident, value, nature, type));
	}
	 
	public void declMeth(String ident, Object value, String type)
	{
		empiler (new Quadruplet(ident, value, "meth", type));
	}
	
	public void affecterVal(String ident, Object value){
		//TODO uniquement  la premire occurence
		Quadruplet zeOne=getMaxElement(ident);
		if(zeOne.nature.equals("vcst")){
			zeOne.nature="cst";
			zeOne.setValue(value);
		}
		else if (zeOne.nature.equals("cst")){
			depiler();
		}
		else{
			zeOne.setValue(value);
		}
	}
	
	public void affecterValT(String ident, String index, String value){
		if(Tas.identTable.containsKey(ident)){
			String address=(String) getMaxElement(ident).value;
			if(value.equals("true")){				
				Tas.affecterTas(true, address, index);
			}
			else if(value.equals("false")){
				Tas.affecterTas(false, address, index);
			}
			else{
				Tas.affecterTas(Integer.parseInt(value), address, index);
			}
		}
		else{
			System.out.println("plizzz reserve table space before affecting values");
		}
	}
	
	public void affecterType(String ident, String type){
		//trouver l'obj et lui mettre un type
		LinkedList playWithMe=(LinkedList) pile.get(ident);
		for(int i=0; i<playWithMe.size(); i++){
			((Quadruplet) (((ArrayList) playWithMe.get(i)).get(0))).type=type;
		}
	}
	
	public Object val(String ident){
		return getMaxElement(ident).getValue();
	}
	
	public String objet(String ident){
		return getMaxElement(ident).nature;
	}
	
	public String sorte(String ident){
		return getMaxElement(ident).type;
	}
	
	public void identVal(String ident, String type, int s){
		
		ArrayList pourInverser=new ArrayList();
		LinkedList listelem=getElementList(s+1);
		int posElemToDel=getElementPos(s+1);
//		changer l'ident du quadruplet
		Quadruplet occurence=((Quadruplet) (((ArrayList) (listelem.get(posElemToDel-1))).get(0)));
		System.out.println("occurence :"+occurence.toString());
		occurence.ident =ident;
		occurence.type=type;
		occurence.nature="var";

		HashMap temp=(HashMap) pile.clone();
		/*
if(pile.size()==1){
	clearStack();
	empiler(occurence);
}else{*/
	int counter=0;
	String thisStackTopIdent=StackTopIdent;
	String tamponIdent=StackTopIdent;
	String pos=null;
	ArrayList StackDisplay=new ArrayList();
	ArrayList memSlot=new ArrayList();
	LinkedList l = (LinkedList) temp.get(StackTopIdent);
	clearStack();
	// building output
	//for(int i=0; i<temp.size()+1; i++){
	while(l!=null){
		
		//System.out.println("pos= "+pos+" taille liste : "+l.size());
		memSlot=(pos!=null)?((ArrayList) l.get(Integer.parseInt(pos)-1)):((ArrayList) l.getLast());
		if(counter!=s){
			empiler((Quadruplet) memSlot.get(0));
			pourInverser.add((Quadruplet) memSlot.get(0));
		}
		else{
			empiler(occurence);
			pourInverser.add(occurence);
		}
		//StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
		thisStackTopIdent=memSlot.get(1).toString();
		pos=memSlot.get(2).toString();
		counter++;
		l=(LinkedList) temp.get(thisStackTopIdent);
	}
		
	showStack();
	//inversion de la pile
	clearStack();
	for(int i=pourInverser.size()-1; i>=0; i--){
		empiler((Quadruplet) pourInverser.get(i));
		System.out.println("empilage de "+((Quadruplet) pourInverser.get(i)).toString());
	}
//}

		
		showStack();
	}
	
	
	public void identVal1(String ident, String type, int s)
	{
		try{
	//		copier la liste correspondant  l'identifiant ident
			LinkedList l=getElementList(s+1);
			int posNew=countList(ident, s);
			posNew=((LinkedList) pile.get(ident)).size()-posNew;
			
			String retrievedElemID=((Quadruplet) (((ArrayList) (l.get(0))).get(0))).ident;
			int posthis=countList(retrievedElemID, s-1);
			//posthis=((LinkedList) pile.get(retrievedElemID)).size()-posthis;
			
			int posElemToDel=getElementPos(s+1);
			
			if(retrievedElemID.equals(StackTopIdent)){
				StackTopIdent=ident;
				System.out.println("changement de nom du sommet de pile");
			}
			
			//changer l'ident du quadruplet
				Quadruplet occurence=((Quadruplet) (((ArrayList) (l.get(posElemToDel-1))).get(0)));
				System.out.println("occurence :"+occurence.toString());
				occurence.ident =ident;
				occurence.type=type;
				occurence.nature="var";
			
//				prparation du tableau  insrer dans la liste de l'lment qui prend un nom donn
				
				ArrayList insert=new ArrayList();
				insert.add(occurence);
				
				System.out.println("s : "+s);
				System.out.println("pile.size : "+pile.size());
				
				//if(s!=pile.size()){
					insert.add((String) (((ArrayList) (l.get(posElemToDel-1))).get(1)));
					insert.add((String) (((ArrayList) (l.get(posElemToDel-1))).get(2)));
					/*
				}
				else{
					insert.add("");
					insert.add("0");
				}
				*/
				System.out.println("insert : "+insert.toString());
			
				ArrayList upperTab = null;
				if(s!=0){
//					maj rf d'ident du quad du dessus
					System.out.println("tableau upper avant modif : "+((ArrayList) getElementList(s).get(getElementPos(s)-1)).toString());
					upperTab=(ArrayList) getElementList(s).get(getElementPos(s)-1);
					upperTab.set(1, ident);
					//maj rf de pos du quad du dessus
					upperTab.set(2, Integer.toString(posNew+1));
				}
				
				System.out.println("liste de b avant insert : "+((LinkedList) pile.get("b")).toString());
			//insertion du tableau insert
				LinkedList changedList=(LinkedList) pile.get(ident);
				LinkedList part1=new LinkedList();
				if(posNew!=0){
					for(int i=0; i<posNew-1;i++){
						part1.addFirst(changedList.get(i));
					}
					part1.addFirst(insert);
					for(int i=posNew-1; i<changedList.size();i++){
						part1.addFirst(changedList.get(i));
					}					
				}
				else{
					if(s==pile.size()){
						part1=changedList;
						part1.addFirst(insert);
					}
					else{
						part1.add(insert);
					}
					
				}
				changedList=part1;
				System.out.println("liste de b aprs insert 1 : "+((LinkedList) pile.get("b")).toString());
				
				pile.put(ident, changedList);
				System.out.println("liste de b aprs put : "+((LinkedList) pile.get("b")).toString());
				l.remove(posElemToDel-1);
				System.out.println("liste de b aprs rem : "+((LinkedList) pile.get("b")).toString());
				
				System.out.println("liste de f avant dcal : "+((LinkedList) pile.get("f")).toString());
				System.out.println("id : "+retrievedElemID);
				System.out.println("posthis : "+posthis);

				if(posthis!=0){
					
					changePointer(retrievedElemID, posthis);
				}
				System.out.println("liste de f aprs dcal : "+((LinkedList) pile.get("f")).toString());
				System.out.println("liste de b aprs dcal : "+((LinkedList) pile.get("b")).toString());
//				showStack();
				
		}catch(Exception e){
			System.out.println("impossible de changer d'identifiant. mmoire non dfinie ou pile non cre : ");
			e.printStackTrace();
		}
	}

	//dcale tous les pointeurs sur ident  partir sommet nbTimeToDo fois pour donner la position=position -1
	private void changePointer(String identDecaled, int nbTimeToDo) {

			String thisStackTopIdent=StackTopIdent;
			String pos=null;
			ArrayList StackDisplay=new ArrayList();
			ArrayList memSlot=new ArrayList();
			LinkedList l = (LinkedList) pile.get(StackTopIdent);;
			// building output
			while(nbTimeToDo!=0){

				l=(LinkedList) pile.get(thisStackTopIdent);
				memSlot=(pos!=null)?((ArrayList) l.get(Integer.parseInt(pos)-1)):((ArrayList) l.getLast());
				if (memSlot.get(1).equals(identDecaled)){
					memSlot.set(2, Integer.toString(Integer.parseInt((String) memSlot.get(2))-1));
					nbTimeToDo--;
				}
				//StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
				thisStackTopIdent=memSlot.get(1).toString();
				pos=memSlot.get(2).toString();
			}
	}
	
	
	
/**
* @param ident
*/
private void decalPointers(String ident, int posElemToDel) {
//	la liste de l'identifiant
	LinkedList thisList=(LinkedList) pile.get(ident);
	//parcours de la pile (table de hash)
	Iterator it = pile.values().iterator();
	    while (it.hasNext()) {
	        // Get Hash Slot
	        LinkedList value = (LinkedList) it.next();
	        Iterator it2=value.listIterator();
	        
	        String tempId;
	        int listPos=0;
	        //goes through list elements
	        while(it2.hasNext()){
	        	ArrayList slot=(ArrayList) it2.next();
	        	
	        	tempId=(String)slot.get(1);
	        	int tempPos=Integer.parseInt((String)slot.get(2));
	        	//si on trouve un slot qui pointe vers celui qu'on va retirer :
	        	if(tempId.equals(ident) && tempPos==posElemToDel){
	        		//gets the slot position to retrieve it
	        		ArrayList decArray=(ArrayList) thisList.get(tempPos-1);
//	        		pointer translation
	        		slot.set(1, decArray.get(1));
	        		slot.set(2, decArray.get(2));
	        		//validation
	        		value.set(listPos, slot);
	        	}
	        	listPos++;
	        }
	    }
}

//	TODO supprime toutes les occurences de ident : vrifier si c ok
	public void retirerDecl(String ident)
	{
		Quadruplet q=getMaxElement(ident);
		//Quadruplet q=(Quadruplet)((ArrayList) ((LinkedList) pile.get(ident)).getLast()).get(0);
		//si c un tableau
		if(q.nature.equals("tab")){
			Tas.retirerTas((descriptionTas) ((LinkedList) Tas.identTable.get(ident)).getLast());
		}
		//si c un tat mem autre que tableau
		else{
			LinkedList listToDel=(LinkedList) pile.get(ident);
			//si c le dernier lment de la liste
			if(listToDel.size()==1){
				decalPointers(ident, 1);
				//on modifie la var globale de stack top si on retire l'id du stack top
				if(StackTopIdent.equals(ident)){
					ArrayList StackTopSlot=(ArrayList) ((LinkedList) pile.get(StackTopIdent)).get(StackTopPos-1);
					StackTopIdent=(String) StackTopSlot.get(1);
					StackTopPos=Integer.parseInt((String) (StackTopSlot.get(2)));
				}
				pile.remove(ident);
				
			}
			//si c pas le dernier qui reste en collisions
			else{
				int temp=listToDel.size();
				
					System.out.println("stack juste avant del :");
					showStack();
				
					System.out.println("stack stackTopPos : "+StackTopPos);
					
					
					if(StackTopIdent.equals(ident)){
						/*
						ArrayList StackTopSlot=(ArrayList) ((LinkedList) pile.get(StackTopIdent)).get(StackTopPos-1);
						StackTopIdent=(String) StackTopSlot.get(1);
						StackTopPos=Integer.parseInt((String) (StackTopSlot.get(2)));
						*/
						depiler();
					}
					else{
						decalPointers(ident, temp);
						listToDel.removeLast();
					}
					System.out.println("stack stackTopPos : "+StackTopPos);
					System.out.println("stack stackTopIdent : "+StackTopIdent);
					System.out.println("stack juste avant decalag :");
					//showStack();
					
				
				
				
					System.out.println("stack juste aprs del :");
					showStack();
					
			}
			
			
		}
	}

	public String valT(String ident, String value){
		
		return Tas.valeurTas((String) getMaxElement(ident).value, value, pile);
	}

	public void expParam(Node lexp, Node ent, ParserVisitor visitor )
	{
		System.out.println("expParam");
		System.out.println("lexp = " + lexp);
		System.out.println("ent = " + ent);
		
		if ((lexp.toString() != "exnil") & (ent.toString() != "enil")) {
			Node le1= (Node)lexp.jjtGetChild(1);
			Node ents = (Node) ent.jjtGetChild(1);
			Object v = lexp.jjtGetChild(0).jjtAccept(visitor, "");
			String i = ent.jjtGetChild(0).jjtGetChild(1).toString();
			String t = ent.jjtGetChild(0).jjtGetChild(0).toString();
			declVar(i,v.toString(),t);
			expParam(le1, ents, visitor);
		}
	}
	
	public Object variableClasse (String nomClasse) {
		
		Object res = getMaxElement(nomClasse).getValue();
		
		return (res);
	}
	

	public Object parametre(String ident){

		Quadruplet cetElement=getMaxElement(ident);
		if(cetElement.nature.equals("meth")){
			
		return null;
		}
		else{
			
			if(cetElement.value.getClass().toString().equals("ASTmethode"))//TODO methode))
			{
				ASTmethode t =(ASTmethode) cetElement.getValue();
				return t.jjtGetChild(2);
				// retourne ents
			}
		}
		return null;
	}
	
	public Object declaration(String ident){
		Quadruplet cetElement=getMaxElement(ident);
		if(!cetElement.nature.equals("meth")){
			return null;
		}
		else{
			if(cetElement.value.getClass().toString().equals("ASTmethode"))//TODO methode))
			{
				ASTmethode t=(ASTmethode) cetElement.getValue();
				return t.jjtGetChild(3);
				// retourne dv
			}
		}
		return null;
	}
	
	public Object corps(String ident){
		Quadruplet cetElement=getMaxElement(ident);
		if(!cetElement.nature.equals("proc")){
			return null;
		}
		else{
			if(cetElement.value.getClass().toString().equals("ASTmethode"))//TODO methode))
			{
				ASTmethode t=(ASTmethode) cetElement.getValue();
				return t.jjtGetChild(4);
				// retourne is
			}
		}
		return null;
	}

	
	public static void main(String[] args){
		
		
		new Memory(256);
		/*
		Quadruplet a=new Quadruplet("a", "Valeur A", "Nature A", "Type A");
		Quadruplet b=new Quadruplet("b", "Valeur : b", "Nature : b", "Type : b");
		empiler(a);
		empiler(b);
		empiler(a);
		empiler(a);
		empiler(b);
		empiler(a);
		System.out.println("appelle declVar() aprs 3 empilages");
		declVar("a", "3", "sonType");
		showStack();
		System.out.println("appelle echanger()");
		echanger();
		showStack();
		System.out.println("appelle identVal()");
		identVal("hello", "", 0);
		showStack();
		System.out.println("appelle depiler()");
		depiler();
		showStack();
		System.out.println("appelle retirerDecl()");
		retirerDecl("b");
		System.out.println("sommet de pile aprs retrait : "+StackTopIdent);
		showStack();
		
		System.out.println("effaage de la pile");
		clearStack();
		showStack();
		
		System.out.println("appelle declCst()");
		declCst("constante", "constValue", "constType");
		showStack();
		System.out.println("appelle declMeth()");
		declMeth("fonction", "valeurFonction", "fonctionType");
		showStack();
		*/
		//expParam(null, null);
	}
	
public void showStack(){
	String thisStackTopIdent=StackTopIdent;
	String pos=null;
	ArrayList StackDisplay=new ArrayList();
	ArrayList memSlot=new ArrayList();
	
	//try{
		if(!pile.isEmpty()){
			System.out.println("");
			System.out.println("StackTopPos : "+StackTopPos);
			System.out.println("---- Stack ---- ");
			System.out.println("");
			
			// building output
			while(!thisStackTopIdent.equals("")){

				//System.out.println("stack id : "+thisStackTopIdent);
				LinkedList l=(LinkedList) pile.get(thisStackTopIdent);				
				System.out.println(" liste : "+l.size());
				
				if(pos!=null && !pos.equals("0")){
					//System.out.println(" liste : "+l.get(Integer.parseInt(pos)-1));
					
						memSlot=((ArrayList) l.get(Integer.parseInt(pos)-1));

					
				}
				else{
					//System.out.println(" liste : "+l.getLast()+", taille : "+l.size());
					memSlot=(ArrayList) l.getLast();
				}
				
				//System.out.println("ident : "+thisStackTopIdent+" | pos : "+pos);
				StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
				//System.out.println(" future stack top ident : "+memSlot.get(1).toString());
				thisStackTopIdent=memSlot.get(1).toString();
				pos=memSlot.get(2).toString();
				//System.out.println("next ident : "+thisStackTopIdent+" | next pos : "+pos);
			}
			// stack display
			for(int i=0; i<StackDisplay.size(); i++){
				System.out.println(StackDisplay.get(i));
			}
			System.out.println("	[	]	");
			System.out.println("");
			System.out.println("---- End of Stack ----");
			System.out.println("");
		}
		else{
			System.out.println("");
			System.out.println("---- La pile est vide ---- ");
			System.out.println("");
			System.out.println("	[	]	");
		}
	/*}catch(NullPointerException e){
		System.out.println("impossible d'afficher la pile. Est-elle cre ? message : ");
		e.printStackTrace();
	}*/
}

public String stringStack(){
	String thisStackTopIdent=StackTopIdent;
	String pos=null;
	ArrayList StackDisplay=new ArrayList();
	ArrayList memSlot=new ArrayList();
	String res = "";
	
	try{
		if(!pile.isEmpty()){
			res += "";
			res += "---- Stack ---- ";
			res += "\n";
			
			// building output
			while(!thisStackTopIdent.equals("")){
				//System.out.println("stack id : "+thisStackTopIdent);
				LinkedList l=(LinkedList) pile.get(thisStackTopIdent);				
				
				
				if(pos!=null && !pos.equals("0")){
					//System.out.println(" liste : "+l.get(Integer.parseInt(pos)-1));
					memSlot=((ArrayList) l.get(Integer.parseInt(pos)-1));
				}
				else{
					//System.out.println(" liste : "+l.getLast());
					memSlot=(ArrayList) l.getLast();
				}
				
				//System.out.println("ident : "+thisStackTopIdent+" | pos : "+pos);
				StackDisplay.add(memSlot.get(0).toString()+", ref : "+memSlot.get(1).toString()+", pos : "+memSlot.get(2).toString());
				//System.out.println(" future stack top ident : "+memSlot.get(1).toString());
				thisStackTopIdent=memSlot.get(1).toString();
				pos=memSlot.get(2).toString();
				//System.out.println("next ident : "+thisStackTopIdent+" | next pos : "+pos);
			}
			// stack display
			for(int i=0; i<StackDisplay.size(); i++){
				res += StackDisplay.get(i) + "\n";
			}
			res += "	[	]	\n";
			res += "";
			res += "---- End of Stack ----\n";
			res += "";
		}
		else{
			res += "";
			res += "---- La pile est vide ----\n ";
			res += "";
			res += "	[	]	\n";
		}
	}catch(NullPointerException e){
		System.out.println("impossible d'afficher la pile. Est-elle cre ? message : ");
		e.printStackTrace();
	}
	
	return res;
}

	private void sorties() {

		System.out.println("Output start");
		System.out.println("");
		// Get number of entries in map
	    int size = pile.size();
	    System.out.println("Hash table size : "+size);
	    /*
	    // Iterate over the keys in the map
	    Iterator it = pile.keySet().iterator();
	    while (it.hasNext()) {
	        // Get key
	        Object key = it.next();
	        System.out.println("cl objet table Hash : "+key.toString());
	    }
	    */
	    // Iterate over the values in the map
	    Iterator it = pile.values().iterator();
	    while (it.hasNext()) {
	        // Get value
	        LinkedList value = (LinkedList) it.next();
	        Iterator it2=value.listIterator();
	        
	        while(it2.hasNext()){
	        	ArrayList memSlot=(ArrayList) it2.next();
	        	//System.out.println("taille du tableau : "+memSlot.size());
	        	System.out.println("Quadruplet : "+memSlot.get(0).toString());
	        	try{
	        		String previousElemIdent=memSlot.get(1).toString();
	        		System.out.println("previous id : "+previousElemIdent+"; Position : "+memSlot.get(2));
	        	}catch(NullPointerException e){
	        		System.out.println("objet bas de pile");
	        	}
	        	
	        }
	    }
		
	}
	
	/**
	 * @param toReturn
	 */
	public String[] makeReturn(int[] toReturn) {
		
		String[] enChaine=new String[toReturn.length];
		HashMap pourIci=new HashMap();
		pourIci=makeClone(pourIci);
		//pourIci=(HashMap)pile.clone();
		
		Iterator refIt=Tas.refTas.values().iterator();
		while(refIt.hasNext()){
			LinkedList listIt=(LinkedList) refIt.next();
			
			Iterator InList=listIt.iterator();
			while(InList.hasNext()){
				descriptionTas ca=(descriptionTas) InList.next();
				try{
					Quadruplet occur=(Quadruplet) ((ArrayList) (((LinkedList) (pourIci.get(ca.ident))).getLast())).get(0);
					
					
					//System.out.println("occur : "+occur.toString());
					
					if(occur.getNature().equals("boolean")){
						
						for(int i=ca.address; i<(ca.address+ca.length); i++){
							int val=toReturn[i];
							if(val==1){
								enChaine[i]="true";
							}
							else{
								enChaine[i]="false";
							}
						}
					}
					else{
						for(int i=ca.address; i<(ca.address+ca.length); i++){
							enChaine[i]=Integer.toString(toReturn[i]);
						}
					}
					((LinkedList) (pourIci.get(ca.ident))).removeLast();
				}catch(NullPointerException e){
					for(int i=ca.address; i<(ca.address+ca.length); i++){
						enChaine[i]="vide";
					}
				}
				
			}
		}
		return enChaine;
	}
	
	/**
	 * @param pourIci
	 * @return
	 */
	private HashMap makeClone(HashMap pourIci) {
		Iterator pileIt=pile.values().iterator();
		while(pileIt.hasNext()){
			LinkedList listePile=(LinkedList)pileIt.next();
			String id=((Quadruplet) ((ArrayList) listePile.getFirst()).get(0)).ident;
			pourIci.put(id, listePile);
		}
			
		return pourIci;
	}

	//affiche le tas dans l'ordre des addresses
	public String[] displayTas2(){
		ArrayList memoire=new ArrayList();
		int[] toReturn;
		toReturn=Tas.HTas;
		String[] enChaine=makeReturn(toReturn);
		
		
		Iterator it=Tas.refTas.values().iterator();
		while(it.hasNext()){
			LinkedList collisionList=(LinkedList) it.next();
			Iterator listIT=collisionList.iterator();
			while(listIT.hasNext()){
				ArrayList slot=new ArrayList();
				descriptionTas d=(descriptionTas) listIT.next();
				slot.add(Integer.toString(d.address));
				slot.add(d);
				memoire.add(slot);
			}
		}
		int address=0;
		int currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(0)).get(0));
		System.out.println("taille du tableau : "+memoire.size());
		for(int i=0; i<memoire.size(); i++){
			int j=0;
			while(currentAdd!=address && j+1<memoire.size()){
				j++;
				currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(j)).get(0));
				//System.out.println("addresse lue : "+currentAdd+", attend "+address);
				
			}
				descriptionTas d=(descriptionTas) ((ArrayList) memoire.get(j)).get(1);
				
				if(d.busy){
					System.out.println("address : "+d.address+", fin : "+(d.address+d.length)+", longueur : "+d.length+", occup : "+d.busy);
				}
				else{
					
				}
				
				currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(0)).get(0));
				address=d.address+d.length;
		}
		System.out.println(enChaine.toString());
		return enChaine;
	}


}
