package ihm;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.border.*;

public class FenetreInterpretation extends JInternalFrame {
	
	JTextArea zoneEcritureMjj;
	JTextArea zoneEcritureJjc;
	JPanel zoneTasMjj, zoneTasJjc;
	JTabbedPane onglet;
	//JScrollPane barreDefilement;
	GridLayout grid = new GridLayout(0,10);
		
	public FenetreInterpretation() {

		setupFenetre();
		creationZoneEcriture();
		creationZoneTas();
		creationOnglet();
		
		
	}
	
	public void setupFenetre() {
		
		/*Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
		int largeurEcran = tailleEcran.width;
		int hauteurEcran = tailleEcran.height;
		int largeur = (largeurEcran - 40)/3;
		int hauteur = (hauteurEcran/2)+20;
		this.setSize(largeur, hauteur);
		this.setLocation(30 + largeur + largeur,10);*/
		this.setTitle("Etat Mmoire Interprtation");
		this.setIconifiable(false);
		this.setClosable(false);
		this.setMaximizable(true);
		this.setResizable(false);
		this.setVisible(true);
		
	}
	
	public void creationOnglet() {
		onglet = new JTabbedPane();
		onglet.addTab("Pile Mjj", creationScrollPane(zoneEcritureMjj));
		onglet.setToolTipTextAt(0,"Vue de la Pile Minijaja");
		onglet.addTab("Pile Jjc", creationScrollPane(zoneEcritureJjc));	
		onglet.setToolTipTextAt(1,"Vue de la Pile Jajacode");
		onglet.addTab("Tas Mjj", creationScrollPane(zoneTasMjj));
		onglet.setToolTipTextAt(2,"Vue du Tas Minijaja");
		onglet.addTab("Tas Jjc", creationScrollPane(zoneTasJjc));
		onglet.setToolTipTextAt(3,"Vue du Tas Jajacode");
		this.setContentPane(onglet);
	}
	
	public void creationZoneEcriture() {
		
		zoneEcritureMjj = new JTextArea(); 
		zoneEcritureMjj.setEditable(false);
		zoneEcritureMjj.setBackground(Color.LIGHT_GRAY);
		zoneEcritureMjj.setForeground(Color.BLUE);
		
		zoneEcritureJjc = new JTextArea(); 
		zoneEcritureJjc.setEditable(false);
		zoneEcritureJjc.setForeground(Color.RED);
		
	}
	
	public void creationZoneTas() {		
		zoneTasMjj = new JPanel(grid); 
		zoneTasMjj.setBackground(Color.LIGHT_GRAY);
		zoneTasMjj.setForeground(Color.BLUE);
		
		zoneTasJjc = new JPanel(grid);
		zoneTasJjc.setBackground(Color.WHITE);
		zoneTasJjc.setForeground(Color.RED);		
	}
	
	public JScrollPane creationScrollPane(java.awt.Component zone) {
		JScrollPane barreDefilement = new JScrollPane(zone);
		return barreDefilement;
	}
		
	public void afficherJjc(String stringJjc) {
		
		zoneEcritureJjc.setText(stringJjc);
		
	}
	
	public void afficherMjj(String stringMjj) {
		
		zoneEcritureMjj.setText(stringMjj);
		
	}
	
	public void afficherTasJjc(String[] tasJjc) {
		int ind=0;
        JLabel tmpLab;
        zoneTasJjc.removeAll();
        
		for (int i=0; i<(tasJjc.length/10 + 1); i++) {
			grid.setRows(grid.getRows()+1);
			for (int j=0; j<10; j++) {
				if (ind<tasJjc.length) {
					tmpLab = createLabel(tasJjc[ind]);
					zoneTasJjc.add(tmpLab);
				}				
				ind++;
			}
		}	
		onglet.repaint();
		
	}
	
	public void afficherTasMjj(String[] tasMjj) {
		int ind=0;
        JLabel tmpLab;
        zoneTasMjj.removeAll();
		
		for (int i=0; i<(tasMjj.length/10 + 1); i++) {
			grid.setRows(grid.getRows()+1);
			for (int j=0; j<10; j++) {
				if (ind<tasMjj.length) {
					tmpLab = createLabel(tasMjj[ind]);
					zoneTasMjj.add(tmpLab);
				}				
				ind++;
			}
		}
		onglet.repaint();
	}
	
	public JLabel createLabel(String text) {
		JLabel tmpLab = new JLabel(text);       
        tmpLab.setBackground(Color.WHITE);
        tmpLab.setForeground(Color.RED);
        tmpLab.setHorizontalAlignment(SwingConstants.CENTER);
        tmpLab.setVerticalAlignment(SwingConstants.CENTER);
        tmpLab.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        tmpLab.setPreferredSize(new Dimension(30,30));
		return tmpLab;
	}
	
	public void clear() {
		zoneEcritureMjj.setText("");
		zoneEcritureJjc.setText("");
		zoneTasMjj.removeAll();
		zoneTasJjc.removeAll();
	}
	
}
