package ihm;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;

public class FenetreJjc extends JInternalFrame {
	
	JTextArea zoneEcriture;
	JTextArea zonePointArret;
	JScrollPane barreDefilement;
	JPanel panneau;
	GridBagConstraints gbc = new GridBagConstraints();
	GridBagLayout gridbag = new GridBagLayout();
	Vector vectorPointArret;
	int largeur, hauteur;	
	
	
	public FenetreJjc() {

		setupFenetreJJC();
		creationPanneau();
		creationZoneEcriture();
		creationZonePointArret();
		creationScrollPane();
		vectorPointArret = new Vector();
		initialisationPointArret();	
		this.ecouteurPointArretJJC();
		//this.ecouteurInternalFrame();
		
	}
	
	public void setupFenetreJJC() {
		
		/*Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
		int largeurEcran = tailleEcran.width;
		int hauteurEcran = tailleEcran.height;
		largeur = (largeurEcran)/4;
		hauteur = (hauteurEcran/2)+20;
		this.setSize(largeur, hauteur);
		this.setLocation(20+largeur,10);*/
		this.setTitle("Jaja Code");
		this.setIconifiable(false);
		this.setClosable(false);
		this.setMaximizable(true);
		this.setResizable(false);
		this.setVisible(true);
		
	}
	
	public void creationPanneau() {
		
		panneau = new JPanel(gridbag);
			
	}
	
	public void creationZoneEcriture() {
		
		zoneEcriture = new JTextArea(); 
		zoneEcriture.setEditable(true);
		gbc.gridx = 2;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 99;		// proportion de ligne occupe
		gbc.weighty = 100;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(zoneEcriture, gbc);
		panneau.add(zoneEcriture);
		
	}
	
	public void creationZonePointArret() {
		
		zonePointArret = new JTextArea();
		zonePointArret.setBackground(Color.CYAN);
		zonePointArret.setEditable(false);
		gbc.gridx = 1;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 1;		// proportion de ligne occupe
		gbc.weighty = 100;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(zonePointArret, gbc);
		zonePointArret.setPreferredSize(new Dimension(10,0));
		panneau.add(zonePointArret);
			
	}
	
	public void creationScrollPane() {
		barreDefilement = new JScrollPane(panneau);
		this.getContentPane().add(barreDefilement);
	}
		
	public void afficherJjc(String stringJjc) {		
		zoneEcriture.setText(stringJjc);
		initialisationPointArret();
	}
	
	public int getNombreLigne() {		
		return zoneEcriture.getLineCount();		
	}
	
	
	public void initialisationPointArret() {
		for (int i=0;i<getNombreLigne();i++) { 
			vectorPointArret.addElement("\n");			
		}	
	}
	
	public void ajoutPointArret(int ligne) {
		vectorPointArret.setElementAt("o\n",ligne-1);
		miseAJourPointArret();
	}
	
	public void retirerPointArret(int ligne) {
		vectorPointArret.setElementAt("\n",ligne-1);
		miseAJourPointArret();
	}
	
	public void miseAJourPointArret() {
		String res = "";
		for (int i=0;i<getNombreLigne();i++) 
			res += vectorPointArret.elementAt(i);
		
		zonePointArret.setText(res);
	}
	
	public Vector getPointsArret() {
		Vector pts = new Vector();
		for (int i=0; i<vectorPointArret.size(); i++) {
			if (vectorPointArret.get(i).equals("o\n")) {
				pts.addElement(new Integer(i+1));
			}
		}
		return pts;
	}
	
	public void ecouteurPointArretJJC() {
		this.zonePointArret.addMouseListener(new MouseListener() {

			public void mouseClicked(MouseEvent arg0) {
				int ligneClic = new Integer(new Integer(arg0.getY()/16).shortValue()+1).intValue();
				
				/*System.out.println("clic = " + new Integer(new Integer(arg0.getY()/16).shortValue()+1));
				System.out.println("sizebool = " + (vectorPointArret.size() >= ligneClic));
				System.out.println("size = " + (vectorPointArret.size()));*/
				if (vectorPointArret.size() >= ligneClic) {
					if (vectorPointArret.elementAt(ligneClic-1) == "o\n") {	
						retirerPointArret(ligneClic);							
					} else {								
						ajoutPointArret(ligneClic);
					}
				}
						
			}

			public void mousePressed(MouseEvent arg0) {
				
			}

			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
						
		});
	}
	
}
