package ihm;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.AttributeSet;

public class FenetreMjj extends JInternalFrame {
	
	JTextArea zoneEcriture;
	JTextArea zonePointArret;
	JTextArea zoneNumeroLigne;
	JScrollPane barreDefilement;
	String cheminFich;
	JPanel panneau;	
	GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();
	int largeur;
	int hauteur;
	int[] tabLigne;
	Vector vectorPointArret;
	
	public FenetreMjj() {

		setupFenetreMjj();
		
		creationPanneau();
		creationZoneEcriture();
		creationZoneNumeroLigne();
		creationZonePointArret();
		creationScrollPane();
		vectorPointArret = new Vector();
		initialisationPointArret();
		this.ecouteurMjj();	
		this.ecouteurPointArretMjj();
	}
	
	public void setupFenetreMjj() {
		
		/*Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();
		int largeurEcran = tailleEcran.width;
		int hauteurEcran = tailleEcran.height;
		largeur = (largeurEcran - 40)/3;
		hauteur = (hauteurEcran/2)+20;
		this.setSize(largeur, hauteur);
		this.setLocation(10,10);*/
		this.setTitle("Sans Titre");
		this.setIconifiable(false);
		this.setClosable(false);
		this.setMaximizable(true);
		this.setVisible(true);
		this.setResizable(false);
		
	}
	
	public void creationPanneau() {
		
		panneau = new JPanel(gridbag);
			
	}
	
	public void creationZoneEcriture() {
		
		zoneEcriture = new JTextArea();
		gbc.gridx = 2;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 90;		// proportion de ligne occupe
		gbc.weighty = 100;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(zoneEcriture, gbc);
		panneau.add(zoneEcriture);
					
	}
	
	public void creationZonePointArret() {
		
		zonePointArret = new JTextArea();
		zonePointArret.setBackground(Color.CYAN);
		zonePointArret.setEditable(false);
		gbc.gridx = 1;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 2;		// proportion de ligne occupe
		gbc.weighty = 100;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(zonePointArret, gbc);
		zonePointArret.setPreferredSize(new Dimension(10,0));
		panneau.add(zonePointArret);
			
	}
	
	public void creationZoneNumeroLigne() {
		
		zoneNumeroLigne= new JTextArea();
		zoneNumeroLigne.setBackground(Color.LIGHT_GRAY);
		zoneNumeroLigne.setText("1");
		zoneNumeroLigne.setEditable(false);
		gbc.gridx = 0;			// numro de colonne
		gbc.gridy = 0;			// numro de ligne
		gbc.gridwidth = 1;		// nombre de colonnes couvertes
		gbc.gridheight = 1;		// nombre de lignes couvertes
		gbc.weightx = 8;		// proportion de ligne occupe
		gbc.weighty = 100;		// proportion de colonne occupe
		gbc.fill = GridBagConstraints.BOTH;	// tirement du composant
		gridbag.setConstraints(zoneNumeroLigne, gbc);
		
		panneau.add(zoneNumeroLigne);
			
	}
	
	public void nouveauFichier() {
		
		zoneEcriture.setText("");
		this.setTitle("Sans Titre");
		initialisationPointArret();		
	}
	
	public void ouvertureFichier(File cheminFichier, String nomFichier) {
		
		BufferedReader entree = null;
		String fichierMjj = "";
		String sautLigne = "";
		
		try {
			
			entree = new BufferedReader(new FileReader(cheminFichier));
			cheminFich = "" + cheminFichier;
		} catch (FileNotFoundException e) {
			
			e.printStackTrace();
		}
		
		try {
			String ligne = "";
			//Tant que l'on lit des lignes dans le fichier 
			while ((ligne = entree.readLine())!= null) {  
				fichierMjj += sautLigne + ligne;
				sautLigne = "\n";
			}
			//On ferme le fichiers de lecture
			entree.close();
				
		} 
		
		catch (IOException e1) {
			e1.printStackTrace();
		}
		
		zoneEcriture.setText(fichierMjj);
		afficherTitre(nomFichier);
		remplirZoneLigne();
		initialisationPointArret();
		
	}
	
	public void enregistrementFichier() {
		BufferedWriter sortie = null;
		
		//On indique le fichier de destination pour l'enregistrement
		try {
			sortie = new BufferedWriter(new FileWriter(cheminFich,false));
		} catch (IOException e) {
			
			e.printStackTrace();
		}
		
		//On lit le document MiniJaja et on le copie dans le fichier de destination
		
		try {
			sortie.write(getTxtMjj());
			//On ferme le fichier considr
			sortie.close();
			//On indique que le fichier est enregistr
			//fichier_enregistre = true;
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		//On met  jour le titre de la fentre MiniJaja
		//MiseAJourTitre();
		
			
	}
	
	public void creationScrollPane() {
		
		barreDefilement = new JScrollPane(panneau);
		this.getContentPane().add(barreDefilement);
		
	}
	
	public void afficherTitre(String nomFichier) {
		
		this.setTitle(nomFichier);
		
		
	}
	
	public String obtenirNomFichier() {
		
		return (this.getTitle());
		
	}
	
	public String getTxtMjj() {
		
		String txtMjj="";
		txtMjj = this.zoneEcriture.getText();
		
		return(txtMjj);
		
	}
	
	public int getNombreLigne() {
		
		return (this.zoneEcriture.getLineCount());
		
	}
	
	public void remplirTableauLigne() {
		
		int nbLigne;
		nbLigne = getNombreLigne();
		tabLigne = new int[nbLigne];
		for (int i=0;i<nbLigne;i++)
			tabLigne[i] = i+1;
		for (int i=0;i<nbLigne;i++)
			System.out.println("res = " + tabLigne[i]);
		
	}
	
	public String stringZoneLigne() {
		
		remplirTableauLigne();
		String res = "";
		for (int i=0;i<getNombreLigne();i++)
			res += i+1 + "\n";
		
		return res;
	}
	
	public void remplirZoneLigne() {
		
		zoneNumeroLigne.setText(this.stringZoneLigne());
		
	}
	
	public void ecouteurMjj() {
		this.zoneEcriture.addKeyListener(new KeyListener() {
			
			public void keyTyped(KeyEvent arg0) {
				remplirZoneLigne();
				initialisationPointArret();
				
			}

			public void keyPressed(KeyEvent arg0) {
				
				
			}

			public void keyReleased(KeyEvent arg0) {
				
				
			}
			
		});
	}
	
	public boolean clicCorrespondPointArret(int ligneClic, Vector v) {
		boolean res = false;
		res = v.contains(new Integer(ligneClic));
		return res;
	}
	
	public void initialisationPointArret() {
		for (int i=0;i<getNombreLigne();i++) { 
			vectorPointArret.addElement("\n");			
		}	
	}
	
	public void ajoutPointArret(int ligne) {
		vectorPointArret.setElementAt("o\n",ligne-1);
		miseAJourPointArret();
	}
	
	public void retirerPointArret(int ligne) {
		vectorPointArret.setElementAt("\n",ligne-1);
		miseAJourPointArret();
	}
	
	public void miseAJourPointArret() {
		String res = "";
		for (int i=0;i<getNombreLigne();i++) 
			res += vectorPointArret.elementAt(i);
		
		zonePointArret.setText(res);
		
	}
	
	public void ecouteurPointArretMjj() {
		this.zonePointArret.addMouseListener(new MouseListener() {

			public void mouseClicked(MouseEvent arg0) {
				
				int ligneClic = new Integer(new Integer(arg0.getY()/16).shortValue()+1).intValue();
				
				/*System.out.println("clic = " + new Integer(new Integer(arg0.getY()/16).shortValue()+1));
				System.out.println("sizebool = " + (vectorPointArret.size() >= ligneClic));
				System.out.println("size = " + (vectorPointArret.size()));*/
				if (vectorPointArret.size() >= ligneClic) {
					if (vectorPointArret.elementAt(ligneClic-1) == "o\n") {	
						retirerPointArret(ligneClic);							
					} else {								
						ajoutPointArret(ligneClic);
					}
				}		
						
			}

			public void mousePressed(MouseEvent arg0) {
				
			}

			public void mouseReleased(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseEntered(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}

			public void mouseExited(MouseEvent arg0) {
				// TODO Auto-generated method stub
				
			}
						
		});
	}
	
		
	
	
	
}
