package interpretation_jjc;

import memoire.*;

public class JJCastore extends JJCObject {

	String ident;
	
	public JJCastore(String ident) {
		this.ident = ident;
	}
	
	public String toString() {
		return("astore("+ident+")");
	}
	
	public int interpretation(Memory memoire, int indice) {
		Quadruplet tmp1 = memoire.getStackTop();
		memoire.depiler();
		Quadruplet tmp2 = memoire.getStackTop();
		memoire.depiler();
		memoire.affecterValT(ident,(String)tmp2.getValue(),(String)tmp1.getValue());
		return indice+1;
	}

}
