package interpretation_jjc;

import memoire.*;

public class JJCinvoke extends JJCObject {

	String ident;
	
	public JJCinvoke(String ident) {
		this.ident = ident;
	}
	
	public String toString() {
		return("invoke("+ident+")");
	}
	
	public int interpretation(Memory memoire, int indice) {
		Quadruplet tmp = new Quadruplet("w",Integer.toString(indice+1),"cst","w");
		memoire.empiler(tmp);
		return Integer.parseInt((String)memoire.val(ident))-1;
	}

}
