package interpretation_jjc;

import memoire.*;

public class JJCload extends JJCObject {

	String ident;
	
	public JJCload(String ident) {
		this.ident = ident;
	}
	
	public String toString() {
		return("load("+ident+")");
	}
	
	public int interpretation(Memory memoire, int indice) {
		Quadruplet tmp = new Quadruplet("w",(String)memoire.val(ident),"cst","w");
		memoire.empiler(tmp);
		return indice+1;
	}

}
