package interpretation_jjc;

import memoire.*;

public class JJCnewarray extends JJCObject {

	String ident, type;
	
	public JJCnewarray(String ident, String type) {
		this.ident = ident;
		this.type = type;
	}
	
	public String toString() {
		return("newarray("+ident+","+type+")");
	}
	
	public int interpretation(Memory memoire, int indice) {
		Quadruplet tmp = memoire.getStackTop();
		memoire.depiler();
		memoire.declTab(ident,Integer.parseInt((String)tmp.getValue()),type);
		return indice+1;
	}

}
