package interpretation_jjc;

import java.io.*;
import java.util.Vector;
import asa.*;
import compilation.*;
import memoire.*;

public class Lanceur {
	public static void main(String args[]) throws ParseException, FileNotFoundException{
		//Parser parser = new Parser(new FileReader(args[0]));
		Parser parser = new Parser(new FileReader("test4.mjj"));
		SimpleNode parseTree = parser.analyse();
		parseTree.dump("");
		Compilateur compile = new Compilateur();
		compile.compilation(parseTree);
		compile.print();
		InterpreteurJJC intjjc = new InterpreteurJJC(compile.getJajacode());
		/*Vector pts = new Vector();
		pts.addElement(new Integer(6));
		pts.addElement(new Integer(20));
		//pts.addElement(new Integer(20));
		intjjc.interpretation(pts);
		//intjjc.getMemoire().showStack();
		System.out.println(intjjc.getMemoire().stringStack());
		intjjc.interpretation(pts);
		//intjjc.getMemoire().showStack();
		System.out.println(intjjc.getMemoire().stringStack());
		intjjc.interpretation(pts);
		//intjjc.getMemoire().showStack();
		System.out.println(intjjc.getMemoire().stringStack());*/
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		intjjc.interpretationPasAPas();
		intjjc.getMemoire().showStack();
		
	}
}