package memoire;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;

/*
 * Created on 11 nov. 2006
 *
 */

/**
 * @author Administrateur
 *
 */
public class Tas {
	
	public int[] HTas; //le tas
	public HashMap refTas; // la table d'accs au tas
	public HashMap identTable; // la table d'accs au tas par ident
	
	//public void main(String[] args){
	public void launch(){
		//new Tas(518);
		
		System.out.println("tas au dbut : ");
		//displayTas2(refTas);
		
		
		System.out.println("");
		System.out.println("cration de newtab");
		System.out.println("");
		creerTas("newtab", 8, false);
		
		System.out.println("");
		System.out.println("cration de newtab");
		System.out.println("");
		creerTas("newtab", 8, false);
		
		System.out.println("");
		System.out.println("cration de newtab");
		System.out.println("");
		creerTas("newtab", 8, false);

		
		System.out.println("");
		System.out.println("cration de tab");
		System.out.println("");
		creerTas("tab", 200, false);
		
		System.out.println("");
		System.out.println("retrait de newtab");
		System.out.println("");
		retirerTas((descriptionTas) (((LinkedList) identTable.get("newtab")).getLast()));
		
		System.out.println("lancement du GC ");
		garbageCollector();
		System.out.println("fin du GC "+refTas.size());
		//displayTas2(refTas);
		
		
		System.out.println("");
		System.out.println("cration d'overflow");
		System.out.println("");
		creerTas("overflow", 256, false);
		
		System.out.println("");
		System.out.println("cration de newt");
		System.out.println("");
		creerTas("newt", 8, false);
		
		System.out.println("");
		System.out.println("cration de t");
		System.out.println("");
		creerTas("newt", 32, false);
		
		System.out.println("");
		System.out.println("cration de newt");
		System.out.println("");
		creerTas("newt", 5, false);
		
		//displayTas2(refTas);
		/*
		//displayTas(refTas);
		affecterTas(true, "0", "0");
		System.out.println(valeurTas("0","0"));
		*/
	}
	
	void show(){
		for (int i=0; i<HTas.length; i++){
			System.out.println("slot "+i+" -> "+HTas[i]);
		}
	}
	
	public Tas(int size){

			HTas=new int[size];
			refTas=new HashMap();
			identTable=new HashMap();
			defFreeSpace(size, 0, false);
	}

	
	/**
	 * @param refTas2
	 */
	//dcoupe l'espace de manire borne, marque l'espace occup ou non suivant la valeur de busy
	private void defFreeSpace(int size, int beginAddress, boolean busy) {

		/*System.out.println("fonction defFreeSpace");
		System.out.println("size : "+size);
		System.out.println("beginAddress : "+beginAddress);
		*/
		int tempSize=size;
		//System.out.println("recherche emplacement de taille : "+tempSize);
		int power=0;
		//on initialise la table d'addresses
		while(tempSize>0)
		{
			int p=(int)Math.pow(2, power);
			if(p>=tempSize)
			{
				int currentSize=0;
				
				if(p==tempSize)
				{	
					currentSize= p;
				}
				else if(p>tempSize){
					power--;
					currentSize=(int) Math.pow(2, power);
				}

				addRef(currentSize, power, beginAddress, busy, "");
				tempSize=tempSize- currentSize;
				beginAddress+=currentSize;
				power=0;
			}
			power++;
		}
		//displayTas(refTas);
	}

	/**
	 * @param currentSize longueur de l'emplacement
	 * @param power la puissance de deux correspondant  la place dans la table rfrences
	 * 
	 */
	//dfinit l'occupation ou non d'une place  l'endroit existingAddress sur une longueur currentSize
	private void addRef(int currentSize, int power, int existingAddress, boolean busy, String ident) {
		descriptionTas d;
		//liste pour la recherche par taille
		try{
			d=new descriptionTas(existingAddress, currentSize, busy, ident, power);
		}catch(NullPointerException e){
			d=new descriptionTas(existingAddress, currentSize, busy, power);
		}
		
		String powerString=Integer.toString(power);
		
		//dtection de collisions
		LinkedList powerList;
		if(!refTas.containsKey(powerString))
		{
			powerList=new LinkedList();
		}
		else{
			powerList=(LinkedList) refTas.get(powerString);
		}
		/*
		System.out.println("");
		System.out.println("dans addref, ajout de l'obj adress "+d.address+", size "+d.length);
		System.out.println("");
		*/
		
		powerList.add(d);
		refTas.put(powerString, powerList);
		
//		idem, pour la recherche par ident
		if(!ident.equals("")){
//			dtection de collisions
			LinkedList identList;
			if(!identTable.containsKey(ident))
			{
				identList=new LinkedList();
			}
			else{
				identList=(LinkedList) identTable.get(ident);
			}
			identList.add(d);
			identTable.put(ident, identList);
			
		}
	}

	//affiche le tas dans l'ordre des addresses
	public void displayTas(HashMap m){
		ArrayList memoire=new ArrayList();
		
		Iterator it=m.values().iterator();
		while(it.hasNext()){
			LinkedList collisionList=(LinkedList) it.next();
			Iterator listIT=collisionList.iterator();
			while(listIT.hasNext()){
				ArrayList slot=new ArrayList();
				descriptionTas d=(descriptionTas) listIT.next();
				slot.add(Integer.toString(d.address));
				slot.add(d);
				memoire.add(slot);
			}
		}
		int address=0;
		int currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(0)).get(0));
		System.out.println("taille du tableau : "+memoire.size());
		for(int i=0; i<memoire.size(); i++){
			int j=0;
			while(currentAdd!=address && j+1<memoire.size()){
				j++;
				currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(j)).get(0));
				//System.out.println("addresse lue : "+currentAdd+", attend "+address);
				
			}
				descriptionTas d=(descriptionTas) ((ArrayList) memoire.get(j)).get(1);
				System.out.println("address : "+d.address+", fin : "+(d.address+d.length)+", longueur : "+d.length+", occup : "+d.busy);
				
				currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(0)).get(0));
				address=d.address+d.length;
		}
	}
	/*
	//affiche le tas dans l'ordre des addresses
	public int[] displayTas2(HashMap m){
		ArrayList memoire=new ArrayList();
		int[] toReturn;
		toReturn=HTas;
		Memory.makeReturn(toReturn);
		
		Iterator it=m.values().iterator();
		while(it.hasNext()){
			LinkedList collisionList=(LinkedList) it.next();
			Iterator listIT=collisionList.iterator();
			while(listIT.hasNext()){
				ArrayList slot=new ArrayList();
				descriptionTas d=(descriptionTas) listIT.next();
				slot.add(Integer.toString(d.address));
				slot.add(d);
				memoire.add(slot);
			}
		}
		int address=0;
		int currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(0)).get(0));
		System.out.println("taille du tableau : "+memoire.size());
		for(int i=0; i<memoire.size(); i++){
			int j=0;
			while(currentAdd!=address && j+1<memoire.size()){
				j++;
				currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(j)).get(0));
				//System.out.println("addresse lue : "+currentAdd+", attend "+address);
				
			}
				descriptionTas d=(descriptionTas) ((ArrayList) memoire.get(j)).get(1);
				
				if(d.busy){
					System.out.println("address : "+d.address+", fin : "+(d.address+d.length)+", longueur : "+d.length+", occup : "+d.busy);
				}
				else{
					
				}
				
				currentAdd=Integer.parseInt((String) ((ArrayList) memoire.get(0)).get(0));
				address=d.address+d.length;
		}
		return HTas;
	}

*/


	/**
	 * @param value
	 * @param type
	 */
	public void retirerTas(descriptionTas desc) {

		//effaage des valeurs
		for(int i=desc.address; i<desc.address+desc.length; i++){
			HTas[i]=0;
		}
		//effaage dans la table de recherche par identifiant
		identTable.remove(desc.ident);
		
		//effaage dans la table de ref et redcoupage
		LinkedList l=(LinkedList) refTas.get(Integer.toString(desc.power));
		Iterator it=l.iterator();
		while(it.hasNext()){
			descriptionTas inList=(descriptionTas) it.next();
			if(inList.equals(desc)){
				l.remove(inList);
				if(l.isEmpty()){refTas.remove(l);}
				System.out.println("");
				System.out.println("appel defFreespace sur args length : "+desc.length+", address : "+desc.address+", boolean : "+false);
				System.out.println("");
				defFreeSpace(desc.length, desc.address, false);
				displayTas(refTas);
				break;
			}
		}

	}

	/**
	 * @param value la valeur  affecter
	 * @param TabAddress l'adresse du tableau dans le tas
	 * @param TabIndex l'index dans le tableau
	 */
	public void affecterTas(int value, String TabAddress, String TabIndex) {
		
		//Integer valueI=Integer.valueOf(value);
		//byte a=valueI.byteValue();
		//byte a=(byte) (value>>>8 &0xFF);
		
		//System.out.println("en bits : "+a);
		
		HTas[Integer.parseInt(TabAddress)+Integer.parseInt(TabIndex)]=value;
	}
	
	//TODO vrifier les valeurs boolennes
	public void affecterTas(boolean value, String TabAddress, String TabIndex) {
		
		if(value){
			HTas[Integer.parseInt(TabAddress)+Integer.parseInt(TabIndex)]=1;
		}else{
			HTas[Integer.parseInt(TabAddress)+Integer.parseInt(TabIndex)]=0;
		}
	}

	/**
	 * @param string
	 * @param value
	 * @return
	 */
	public String valeurTas(String address, String index, HashMap pile) {
		
		//parcours du tas pour voir si c pas un boolen
		Iterator it=refTas.values().iterator();
		while(it.hasNext()){
			LinkedList refTasL=(LinkedList) it.next();
			Iterator InList=refTasL.iterator();
			while(InList.hasNext()){
				descriptionTas ca=(descriptionTas) InList.next();
				if(ca.address==Integer.parseInt(address)){
					try{
						Quadruplet occur=(Quadruplet) ((ArrayList) (((LinkedList) (pile.get(ca.ident))).getLast())).get(0);
						if(occur.nature.equals("boolean")){
							int booleanValue=HTas[Integer.parseInt(address)+Integer.parseInt(index)];
							if(booleanValue==1){
								return "true";
							}
							else{
								return "false";
							}
						}
						else{
							return Integer.toString(HTas[Integer.parseInt(address)+Integer.parseInt(index)]);
						}
					}
					//si la rfrence du tas ne pointe sur rien
					catch(NullPointerException e){
						System.out.println("!!!!!!!!!!!!!>>> tu recherches une valeur  une address du tas o il n'y a rien gros kk <<!!!!!!!!!!!!!!");
					}
				}
			}
		}
		return null;
	}

	//juste pour tre en accord avec l'nonc en respectant mes choix
	public String creerTas(String ident, int size){
		return(creerTas(ident, size, false));	
	}
	/**
	 * @param ident
	 * @param value
	 * @return
	 */
	public String creerTas(String ident, int size, boolean garbageCollected) {
		
		//TODO faire en sorte que size soit en nombre d'octets
		System.out.println("taille de la table de ref (creertas) : "+refTas.size());
		int i=0;
		int j=0;
		
		//on cherche une place libre
		while(i<refTas.size()){

			String powerOf2=Integer.toString(j);
			LinkedList refList=((LinkedList) refTas.get(powerOf2));
			
			//rcupration de la liste d'identifiants
			if(refList!=null)
			{
				//parcourt de la liste de refs  la meme puissance
			Iterator it=refList.iterator();
			while(it.hasNext()){
				descriptionTas parsedElem=((descriptionTas) it.next());
				if(parsedElem.busy==false && parsedElem.length>=size)
				{
					System.out.println("l'emplacement convient. address : "+parsedElem.address+", taille : "+parsedElem.length+", puissance de 2 : "+powerOf2);
					
					/*
					 * redcouper parsedElem  partir de l'addresse de parsedElem+size
					 * ajouter le tableau pile  l'addresse de parsedElem
					 */
					
					insertRef(powerOf2, parsedElem, size, ident);
					System.out.println("le TAS : ");
							displayTas(refTas);

					//retourne l'addresse o on a plac le tableau
					return(Integer.toString(parsedElem.address));
				}
			}
			i++;
			}
			j++;
		}
		if(garbageCollected){
			System.out.println("le tas est plein et il n'y a pas de place pour ajouter "+ident);
		}else{
			System.out.println("lancement auto du garbage collector");
			garbageCollector();
			creerTas(ident, size, true);
		}
		//ne passe pas l normalement
		return null;
	}


	/**
	 * ralise l'ajout d'un lment dans la rfrence du tas
	 * --> travaille sur un espace born de rfrences au tas
	 * @param power2
	 * @param parsedElem
	 * @param i
	 */
	private void insertRef(String powerOf2, descriptionTas parsedElem, int tabSize, String ident) {

		int freeSpaceInSlot=parsedElem.length-tabSize;

		//efface le slot libre dans lequel on ajoute le tableau
		
		LinkedList tmp=(LinkedList) (refTas.get(powerOf2));
		
		
		System.out.println("");
		System.out.println("");
		for(int i=0; i<tmp.size();i++){
			descriptionTas d=((descriptionTas) tmp.get(i));
			System.out.println("linkedlist : add : "+d.address+"fini "+(d.address+d.length));
		}
		
		System.out.println("");
		System.out.println("");
		tmp.removeLast();
		

		System.out.println("");
		System.out.println("appel addref pour taille "+tabSize+", puissance "+parsedElem.power+", address "+parsedElem.address);
		System.out.println("");
		addRef(tabSize, parsedElem.power, parsedElem.address, true, ident);
		//redfinit la place libre du slot utilis
		if(freeSpaceInSlot!=0){

			System.out.println("free space : "+freeSpaceInSlot+"address : "+(parsedElem.address+tabSize));
			System.out.println("avant def ");
				defFreeSpace(freeSpaceInSlot, parsedElem.address+tabSize, false);
			displayTas(refTas);
			System.out.println("aprs def");
		}
	}

	 void garbageCollector(){
	 	
	 	/*
	 	 * parcourir refTable et enregistrer toutes les addresses occupes dans un arrayList.
	 	 * 
	 	 * les mettre bout  bout 	==> changer les addresses des desc et le freespace  true par la meme occasion
	 	 * 							==> effacer refTas
	 	 * 							==> recopier les lments par defFreeSpace  true
	 	 * 
	 	 * defFreeSpace de l'espace libre (aprs la dernire addresse + longueur descriptionTas)
	 	 * 
	 	 */
	 	System.out.println("taille reftas : "+refTas.size());
	 	HashMap tampon=refTas;
	 	refTas=new HashMap();
	 	
	 	Iterator it=tampon.values().iterator();
	 	int currentPosition=0;
	 	
		while(it.hasNext()){
			LinkedList collisionList=(LinkedList) it.next();
			Iterator listIT=collisionList.iterator();
			while(listIT.hasNext()){
				descriptionTas d=(descriptionTas) listIT.next();
				if(d.busy){
					d.address=currentPosition;
					currentPosition+=d.length;
					System.out.println("dplacement slot mmoire");
					addRef(d.length, d.power, d.address, true, d.ident);
					
				}
			}
		}

		//addRef(int currentSize, int power, int existingAddress, boolean busy, String ident)
		
		
		System.out.println("size of free space : "+((HTas.length)-currentPosition)+", current position : "+currentPosition);
		System.out.println("taille de la table de ref (gc) : "+refTas.size());
		defFreeSpace((HTas.length)-currentPosition, currentPosition, false);
		displayTas(refTas);
		System.out.println("fin du GC");
	 }
}
